package com.example.demo.controllers

import com.example.demo.entities.User
import com.example.demo.repositories.UserRepository
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.web.bind.annotation.*

@RestController
class UsersController {
    @Autowired
    lateinit var repo: UserRepository

    @GetMapping("/users")
    fun index(): MutableIterable<User> {
        return repo.findAll()
    }

    @GetMapping("/users/{id}")
    fun show(@PathVariable id: Long): User? {
        return repo.findById(id).get()
    }

    @PostMapping("/users")
    fun create(@RequestBody newUser: User): User {
        return repo.save(newUser)
    }

    @PatchMapping("/users/{id}")
    fun update(@PathVariable id: Long, @RequestBody user: User): User {
        user.id = id
        return repo.save(user)
    }

    @DeleteMapping("/users/{id}")
    fun destroy(@PathVariable id: Long) {
        return repo.deleteById(id)
    }
}
